Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/FSSPData.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/FSSPData.cs	(revision 16828)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/FSSPData.cs	(revision 16828)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances {
+  public class FSSPData {
+    /// <summary>
+    /// The name of the instance.
+    /// </summary>
+    public string Name { get; set; }
+    /// <summary>
+    /// The description of the instance.
+    /// </summary>
+    public string Description { get; set; }
+    /// <summary>
+    /// The count of jobs.
+    /// </summary>
+    public int Jobs { get; set; }
+    /// <summary>
+    /// The count of machines.
+    /// </summary>
+    public int Machines { get; set; }
+    /// <summary>
+    /// The processing times for each combination of machine/job.
+    /// </summary>
+    public double[,] ProcessingTimes { get; set; }
+    /// <summary>
+    /// The best-known schedule.
+    /// </summary>
+    public int[] BestKnownSchedule { get; set; }
+    /// <summary>
+    /// The quality of the best-known schedule.
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/LOPData.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/LOPData.cs	(revision 16828)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances/3.3/Types/LOPData.cs	(revision 16828)
@@ -0,0 +1,58 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Problems.Instances {
+  /// <summary>
+  /// Describes instances of the Linear Ordering Problem (LOP).
+  /// </summary>
+  public class LOPData {
+    /// <summary>
+    /// The name of the instance
+    /// </summary>
+    public string Name { get; set; }
+
+    /// <summary>
+    /// Optional! The description of the instance
+    /// </summary>
+    public string Description { get; set; }
+
+    /// <summary>
+    /// The size of the Matrix
+    /// </summary>
+    public int Dimension { get; set; }
+
+    /// <summary>
+    /// An NxN Matrix
+    /// </summary>
+    public double[,] Matrix { get; set; }
+
+    /// <summary>
+    /// Optional! The best known Permutation
+    /// </summary>
+    public int[] BestKnownPermutation { get; set; }
+
+    /// <summary>
+    /// Optional! The quality value of the <see cref="BestKnownPermutation"/>
+    /// </summary>
+    public double? BestKnownQuality { get; set; }
+  }
+}